--SAM turret script made by Loooser--

if loooser==nil then loooser={} end
loooser.samturret={}
loooser.samturret.object={}
loooser.samturret.rocket={} --attacks rockets
loooser.samturret.missile={} -- attacks aircraft like helis

--Loading images and sounds
loooser.samturret.gfx_icon=loadgfx("weapons/samturretico.png")
setmidhandle(loooser.samturret.gfx_icon)
loooser.samturret.gfx_wpn=loadgfx("weapons/halterung.png")
setmidhandle(loooser.samturret.gfx_wpn)
loooser.samturret.gfx_wpn2=loadgfx("weapons/missilebattery.bmp")
setmidhandle(loooser.samturret.gfx_wpn2)
loooser.samturret.sfx_build=loadsfx("throw.ogg")
loooser.samturret.sfx_bounce=loadsfx("bounce.wav")
loooser.samturret.gfx_pro=loadgfx("weapons/homingmissile.bmp")
loooser.samturret.sfx_attack=loadsfx("homing.wav")
setmidhandle(loooser.samturret.gfx_pro)
loooser.samturret.gfx_cross=loadgfx("gui_no.png")
setmidhandle(loooser.samturret.gfx_cross)
--------------------------------------------------------------------------
--Weapon: SAM Turret
--------------------------------------------------------------------------

loooser.samturret.id=addweapon("loooser.samturret","SAM Turret",loooser.samturret.gfx_icon,0,0)

function loooser.samturret.draw()
	hudpositioning(pos_build,loooser.samturret.gfx_icon)
	hudmapborder()
end

function loooser.samturret.attack(attack)
	if (weapon_shots<=0) and (weapon_position==1) then
		weapon_shots=weapon_shots+1
		useweapon(1)
		playsound(loooser.samturret.sfx_build)
		createobject(loooser.samturret.object.id,weapon_x,weapon_y)
		endturn()
	end
end

--------------------------------------------------------------------------
--Object: SAM Turret
--------------------------------------------------------------------------

loooser.samturret.object.id=addobject("loooser.samturret.object",loooser.samturret.gfx_wpn)

function loooser.samturret.object.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=60
	objects[id].sy=0
	objects[id].wpn_gfx=loooser.samturret.gfx_wpn2
	objects[id].rot=300
	objects[id].ldir=1
	objects[id].mfired=0
	objects[id].player=playercurrent()
	objects[id].timer=0
end

function loooser.samturret.object.draw(id,x,y)
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(0)
	-- Draw
	drawimage(loooser.samturret.gfx_wpn,x,y)
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(objects[id].rot)
	drawimage(objects[id].wpn_gfx,x,y-7)
	
end

function loooser.samturret.object.update(id,x,y)
	
	if objects[id].health<=0 then
	arealdamage(x,y,70,20)
        terrainexplosion(x,y,20,1)
	grey=math.random(0,40)
        if math.random(0,1)==1 then
        	terrainalphaimage(gfx_crater100,x,y,math.random(6,9)*0.1,grey,grey,grey)
        else
        	terrainalphaimage(gfx_crater125,x,y,math.random(6,9)*0.1,grey,grey,grey)
        end
        removeobject(id)
	return	
	end
	objects[id].sy=objects[id].sy+getgravity()
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
                y=y+msuby
                if collision(loooser.samturret.gfx_wpn,x,y,1,1,1,-1,id)==1 then
                        if (math.abs(objects[id].sy)>0.5) then playsound(loooser.samturret.sfx_bounce) end
                        y=y-msuby
                        objects[id].sy=-objects[id].sy*0.3
                        msuby=-msuby*0.3
                end
                -- Water
                if y>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,x,y)
                        playsound(sfx_hitwater1)
                        -- Remove
                        removeobject(id)
                        return
                end
        end
	objectposition(id,x,y)
	objects[id].timer=objects[id].timer+1
	
	if objects[id].timer>=50 then
		objects[id].timer=0
		particle(p_muzzle,x,y-16)
		local team=getplayeralliance(objects[id].player)
		if team==1 then particlecolor(0,255,0) end
		if team==2 then particlecolor(255,255,0) end
		if team==3 then particlecolor(255,0,0) end
		if team==4 then particlecolor(80,200,255) end
		if team==5 then particlecolor(180,60,255) end
		if team==6 then particlecolor(255,180,0) end
		if team==7 then particlecolor(0,180,0) end
		if team==8 then particlecolor(50,100,255) end
		particlesize(0.25,0.25)
		particlealpha(1.0)
		particlefadealpha(0.05)
	end
	if getplayeralliance(objects[id].player)~=getplayeralliance(playercurrent()) then
		local allobjects=objecttable()
		for i=1,#allobjects do
			if objects[allobjects[i]]~=nil and objects[allobjects[i]].brate~=nil and objects[allobjects[i]].exists~=nil then -- solved
				if objects[allobjects[i]].exists==100 then 
				local dist=((x-getobjectx(allobjects[i]))^2+(y-getobjecty(allobjects[i]))^2)^0.5
				if dist<500 then
					aimangleneeded=math.deg(math.atan2(getobjectx(allobjects[i])-x,-(getobjecty(allobjects[i])-y)))
					objects[id].rot=objects[id].rot+angledelta(objects[id].rot,aimangleneeded)*0.8
					if math.abs(angledelta(objects[id].rot,aimangleneeded))<10 then
						--right direction
						local ok=1
						for setx=1,dist,5 do
							if collision(col3x3,x+setx*math.sin(objects[id].rot),y+setx*math.cos(objects[id].rot),1,1,1,-1,id)==1 then
								ok=0; break;
							end
						end
						if objects[id].mfired==0 and ok==1 then
							objects[id].mfired=1
							playsound(loooser.samturret.sfx_attack)
							iid=createprojectile(loooser.samturret.missile.id)
							projectiles[iid]={}
							projectiles[iid].ignore=id
							-- Set initial position of projectile
							projectiles[iid].x=x+math.sin(math.rad(objects[id].rot))*10.0
							projectiles[iid].y=y+3-math.cos(math.rad(objects[id].rot))*10.0
							projectiles[iid].timer=50
							projectiles[iid].ob=id
							projectiles[iid].object=allobjects[i]
							-- Initial movement
							projectiles[iid].sx=math.sin(math.rad(objects[id].rot))*10
							projectiles[iid].sy=-math.cos(math.rad(objects[id].rot))*10
			
						end
						
					end
				end
				end	
			end
		end	
	end
	
end

function loooser.samturret.object.damage(id,damage)
	objects[id].health=objects[id].health-damage		

end

--------------------------------------------------------------------------------
-- Projectile: Missile
--------------------------------------------------------------------------------

loooser.samturret.missile.id=addprojectile("loooser.samturret.missile")		-- Add Projectile

function loooser.samturret.missile.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(loooser.samturret.gfx_pro,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(0.5,0.5)
	setrotation(0)
	drawimage(loooser.samturret.gfx_cross,getobjectx(projectiles[id].object),getobjecty(projectiles[id].object))
end

function loooser.samturret.missile.update(id)						-- Update
	loooser.samturret.missile.move(id,1)
end

function loooser.samturret.missile.move(id,fx)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Particle Tail
	if (fx==1) then
		particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlefadealpha(0.01)
		particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
		particlefadealpha(0.04)
	end
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Homing
	explode=0
	if fx==1 then
	projectiles[id].timer=projectiles[id].timer-1
	end
		-- Homing Calculation
		aimangle=math.deg(math.atan2(getobjectx(projectiles[id].object)-projectiles[id].x,-(getobjecty(projectiles[id].object)-projectiles[id].y)))
		speed=math.sqrt(math.pow(projectiles[id].sx,2)+math.pow(projectiles[id].sy,2))
		if speed<2.0 then
			speed=speed+0.15
			if speed>2.0 then speed=2.0 end
		end
		rot=rot+angledelta(rot,aimangle)*1,5
		projectiles[id].sx=math.sin(math.rad(rot))*speed
		projectiles[id].sy=-math.cos(math.rad(rot))*speed	
		-- Timeout
		if projectiles[id].timer<=-250 then
			explode=1
		end
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3)==1 or explode==1 then
			if terraincollision()==1 or objectcollision()~=projectiles[id].ignore or playercollision()>0 or explode==1 then
				arealdamage(projectiles[id].x,projectiles[id].y,100,150)
				terrainexplosion(projectiles[id].x,projectiles[id].y,25,1)
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				objects[projectiles[iid].ob].mfired=0
				-- Free projectile
				freeprojectile(id)
				break
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			break
		end
	end
end
